>From e38ba5751663adc3e8738236aaae1e526b0ab3e2 Mon Sep 17 00:00:00 2001
From: Tadas Slotkus <devtadas@gmail.com>
Date: Tue, 16 Aug 2011 14:24:25 +0300
Subject: [carFl mem 11/65] Introduce globals structure

Also add globals init mechanism here.

Nearly every function will use a pointer to globals structure
that is located in the main function.

Signed-off-by: Tadas Slotkus <devtadas@gmail.com>
---
 cli_classic.c |    2 +-
 flash.h       |    7 ++++++-
 flashrom.c    |    7 ++++++-
 3 files changed, 13 insertions(+), 3 deletions(-)

diff --git a/cli_classic.c b/cli_classic.c
index 086bd86..7317881 100644
--- a/cli_classic.c
+++ b/cli_classic.c
@@ -96,7 +96,7 @@ static void cli_classic_abort_usage(void)
 	exit(1);
 }
 
-int cli_classic(int argc, char *argv[])
+int cli_classic(globals *g, int argc, char *argv[])
 {
 	unsigned long size;
 	/* Probe for up to three flash chips. */
diff --git a/flash.h b/flash.h
index 7c044bf..b1e9af8 100644
--- a/flash.h
+++ b/flash.h
@@ -39,6 +39,7 @@
 #define TIMEOUT_ERROR	-101
 
 typedef unsigned long chipaddr;
+typedef struct globals globals;
 
 int register_shutdown(int (*function) (void *data), void *data);
 void *programmer_map_flash_region(const char *descr, unsigned long phys_addr,
@@ -259,7 +260,7 @@ int print(int type, const char *fmt, ...) __attribute__((format(printf, 2, 3)));
 #define msg_cspew(...)	print(MSG_BARF, __VA_ARGS__)	/* chip debug barf  */
 
 /* cli_classic.c */
-int cli_classic(int argc, char *argv[]);
+int cli_classic(globals *g, int argc, char *argv[]);
 
 /* layout.c */
 int read_romlayout(char *name);
@@ -278,4 +279,8 @@ int spi_send_command(unsigned int writecnt, unsigned int readcnt,
 int spi_send_multicommand(struct spi_command *cmds);
 uint32_t spi_get_valid_read_addr(void);
 
+struct globals {
+};
+void init_globals(globals *g);
+
 #endif				/* !__FLASH_H__ */
diff --git a/flashrom.c b/flashrom.c
index 18f3021..bb06752 100644
--- a/flashrom.c
+++ b/flashrom.c
@@ -106,6 +106,9 @@ enum programmer programmer =
 #endif
 ;
 #endif
+void init_globals(globals *g)
+{
+}
 
 static char *programmer_param = NULL;
 
@@ -1809,7 +1812,9 @@ void check_chip_supported(const struct flashchip *flash)
 
 int main(int argc, char *argv[])
 {
-	return cli_classic(argc, argv);
+	globals g;
+	init_globals(&g);
+	return cli_classic(&g, argc, argv);
 }
 
 /* FIXME: This function signature needs to be improved once doit() has a better
-- 
1.7.6

